<?php
// AutoDirector database setup
$defaults='MYSQLHOST;MYSQLDBNAME;MYSQLDBUSER;MYSQLDBPASS;INCLUDEFOLDER;IMAGEFOLDER;DATAFOLDER;CLIENTFOLDER;UPLOADSIZELIMIT;UPLOADTIMELIMIT;IMPORTPROFILES;IMPORTDATA;SUPPORTEMAIL;TITLE;ADVERT;ADVERTURL;LICENCEKEY;';

$inifile='autodirector.ini';
$ini=parse_ini_file($inifile);
foreach ($ini as $key=>$value) {
	define($key, $value);
	$defaults=str_replace($key.';', '', $defaults);
}
unset($ini);

// missing application defaults
if ($defaults!='') {
	print "The following parameters are missing from the $inifile file:\n $defaults";
	exit;
}
unset($defaults);

// ________________________________________________________
// MAIN APPLICATION

// PHP includes
require(INCLUDEFOLDER.'dbhandler.php');
require(INCLUDEFOLDER.'adfunctions.php');
require(INCLUDEFOLDER.'adsite.php');

// set defaults
define('THISURL', $_SERVER['PHP_SELF']);
define('FULLURL', scriptPath());
$now=date('Y-m-d H:i:s');
$nowts=date('YmdHis');

// page header
$pagetitle='system setup';
require(INCLUDEFOLDER.'adpagehead.php');
print '<script type="text/javascript">function start() {}</script>';

$start=getvar('start');
if ($start!='go') showInformation();
else {

	print '<p>Connecting to database "'.MYSQLDBNAME.'" on "'.MYSQLHOST.'" ... ';

	// setup database object
	$db=new dbObject;
	if ($db->dbConnect()) {
		print 'success.</p>';

		// drop user table
		$sql='drop table if exists `users`;';
		print '<p>Dropping existing "users" table ... ';
		if ($db->fetch($sql)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>.</p>';

		// create user table
		$sql="CREATE TABLE `users` (`email` varchar(100) NOT NULL default '',`password` varchar(20) NOT NULL default '',`supervisor` tinyint(1) unsigned NOT NULL default '0',`adminsites` text,`usersites` text,`lastlogin` datetime default NULL,`userupdate` varchar(100) default NULL,`lastupdate` datetime default NULL,PRIMARY KEY(`email`),FULLTEXT KEY `adminsites` (`adminsites`,`usersites`)) ENGINE=MyISAM;";
		print '<p>Creating the "users" table ... ';
		if ($db->fetch($sql)) {
			print 'success.</p>';

			// create super user
			$sql="INSERT INTO `users` VALUES ('super@user.account','super',1,'','','$now','autodirector@setup','$now');";
			print '<p>Creating the "super@user.account" with password "super" in the "users" table ... ';
			if ($db->fetch($sql)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. You will not be able to log on.</p>';
		}
		else print '<b style="color:#f00;">FAILED</b>. You will not be able to log on.</p>';


		// drop site table
		$sql='drop table if exists `sites`;';
		print '<p>Dropping existing "sites" table ... ';
		if ($db->fetch($sql)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>.</p>';

		// create site table
		$sql="CREATE TABLE `sites` (`siteid` varchar(20) NOT NULL default '',`emailsales` varchar(100) NOT NULL default '',`currency` varchar(5) NOT NULL default 'GBP',`maxusers` tinyint(1) unsigned NOT NULL default '1',`maxentries` smallint(2) unsigned NOT NULL default '10',`maxpics` tinyint(1) unsigned NOT NULL default '1',`picdimension` smallint(2) unsigned NOT NULL default '600',`forcedimension` tinyint(1) unsigned NOT NULL default '0',`thumbdimx` tinyint(1) unsigned NOT NULL default '80',`thumbdimy` tinyint(1) unsigned NOT NULL default '60',`picturenum` mediumint(3) unsigned NOT NULL default '0',`options` tinyint(1) unsigned NOT NULL default '4',`alert` tinyint(1) unsigned NOT NULL default '0',`userupdate` varchar(100) default NULL,`lastupdate` timestamp NOT NULL,PRIMARY KEY(`siteid`)) ENGINE=MyISAM;";
		print '<p>Creating the "sites" table ... ';
		if ($db->fetch($sql)) {
			print 'success.</p>';

			// add example site
			$sql="INSERT INTO `sites` VALUES ('example','email@example.com','GBP',1,20,3,400,0,80,60,33,7,14,'autodirector@setup',$nowts);";
			print '<p>Adding "example" site to "sites" table ... ';
			if ($db->fetch($sql)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. The "example" site will not be available.</p>';

		}
		else print '<b style="color:#f00;">FAILED</b>. You will not be able to create sites.</p>';


		// drop example table
		$sql='drop table if exists `example`;';
		print '<p>Dropping existing "example" table ... ';
		if ($db->fetch($sql)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>.</p>';

		$sql="CREATE TABLE `example` (`id` smallint(2) unsigned NOT NULL default '0',`display` tinyint(1) unsigned NOT NULL default '1',`new` tinyint(1) unsigned NOT NULL default '0',`year` year(4) default NULL,`make` varchar(30) NOT NULL default '',`model` varchar(30) NOT NULL default '',`type` varchar(30) default NULL,`regnumber` varchar(20) default NULL,`mileage` mediumint(3) unsigned default NULL,`colour` varchar(30) default NULL,`gearbox` enum('unknown','manual','automatic','tiptronic') NOT NULL default 'unknown',`info` text,`price` mediumint(3) unsigned default NULL,`picturelist` varchar(100) default NULL,`views` mediumint(3) unsigned NOT NULL default '0',`enquiries` mediumint(3) unsigned NOT NULL default '0',`userupdate` varchar(100) default NULL,`lastupdate` datetime default NULL,PRIMARY KEY(`id`),KEY `make` (`make`),KEY `price` (`price`),KEY `model` (`model`),KEY `year` (`year`),FULLTEXT KEY `fulltext` (`make`,`model`,`type`,`colour`,`info`)) ENGINE=MyISAM;";
		print '<p>Creating the "example" table ... ';
		if ($db->fetch($sql)) {
			print 'success.</p>';

			print '<p>Adding vehicles to the "example" table: ';

			$adinfo="\r\n\r\n-Example vehicle\r\nThis car is shown on the AutoDirector example site and is _not_ for sale. Vehicle images are poor since they are highly compressed to reduce the size of the installation.\r\n\r\nAutoDirector allows car dealers to manage their own web showroom. Visit _((http://www.autodirector.co.uk/))_ for more information.";

			$sql="INSERT INTO `example` VALUES (1,1,0,2000,'Ferrari','360','Modena','',5000,'ferrari yellow','tiptronic','Is 0 to 60mph in 4.2 seconds fast enough for you? How about a top speed of 189mph? With 395bhp V8 engine and the most stunning curves, the Ferrari 360 is the ultimate car.$adinfo',95000,'1,2,3',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '1, '; else print '<b>1 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (2,1,0,2002,'Mini','Cooper','S','',8000,'british racing green','manual','The Mini is a classic British car that is small, economical and incredible fun to drive. This Mini is a little different: a supercharged inline 1600cc engine will power you from 0 to 60 in 6.5 seconds to reach a top speed of 141mph.$adinfo',19500,'4,5,6',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '2, '; else print '<b>2 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (3,1,0,1997,'McLaren','F1','','',1000,'silver','manual','This is the nearest you can get to a Formula 1 car on the road. The McLaren F1 is one of the fastest vehicles in the world with a top speed of 240mph and 0 to 60 in just 3.2 seconds. And all this for only half a million?!$adinfo',500000,'7,8,9',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '3, '; else print '<b>3 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (4,1,0,2002,'Aston Martin','V12 Vanquish','','',4000,'gun metal grey','manual','If James Bond can drive one, then you must be able to? This car may not have an ejector seat or heat seeking missiles, but you cannot go wrong with a top speed of 190mph and stunning looks like this.$adinfo',150000,'10,11,12',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '4, '; else print '<b>4 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (5,1,0,1995,'Lotus','Esprit','S4S','',0,'yellow','manual','The Esprit may have a 30 year-old design, but it is still one of the most beautiful cars Lotus ever produced. Its turbo-charged inline 2174cc engine provides 300bhp and a top speed of 165mph.$adinfo',45000,'13,14,15',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '5, '; else print '<b>5 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (6,1,0,1999,'Mitsubishi','3000GT','VR-4','',8000,'red','manual','Mitsubishi produce some stunning sports cars, and this 3000GT is no exception. Its twin-turbo 2972cc engine will power you from 0 to 60mph in just 5.5 seconds, but it still manages 25 miles to the gallon.$adinfo',25000,'16',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '6, '; else print '<b>6 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (7,1,1,2003,'Rolls-Royce','Phantom','','',50,'bronze','automatic','Renowned as the worlds best cars, you will not go unnoticed in this gorgeous Rolls-Royce. It provides the ultimate in comfort with a top speed of 149mph and 0 to 60 in 5.7 seconds.$adinfo',250000,'17,18,19',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '7, '; else print '<b>7 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (8,1,0,2002,'TVR','Tuscan','S','',4500,'black','manual','At just 2400lbs, the TVR provides Ferrari-like speed and looks with a \"budget\" price. From 0 to 60mph in just 3.9 seconds, you will soon be at the top speed of almost 200mph.$adinfo',45000,'20,21',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '8, '; else print '<b>8 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (9,1,1,2003,'Vauxhall','VX220','Turbo','',100,'red','manual','The VX220 is not one of Vauxhall\'s typical cars. Designed by Lotus, this vehicle provides excellent performance with gorgeous looks. 0 to 60 is just 4.7 seconds, with a top speed of 151mph.$adinfo',26000,'22,23',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '9, '; else print '<b>9 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (10,1,0,1995,'Toyota','MR2','Turbo','',15000,'red','manual','The MR2 remains one of Toyota\'s most popular sports cars. With stunning curves and a top speed of 145mph, it is not surprising.$adinfo',20000,'24',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '10, '; else print '<b>10 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (11,1,0,1985,'Lamborghini','Countach','LP500 QV','',25000,'red','manual','It is impractical. It will not fit in your garage. It is not easy to get in to. But who cares - everyone will notice you in a Lamborghini, especially when you reach the top speed of 182mph.$adinfo',65000,'25,26',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '11, '; else print '<b>11 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (12,1,1,2003,'Jaguar','XKR','','',150,'silver','automatic','If you want a stylish convertable, this could be the car for you. This Jaguar has stunning curves and a top speed of 155mph.$adinfo',75000,'27',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '12, '; else print '<b>12 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (13,1,0,2002,'Ford','Focus','RS','',12000,'dark blue','manual','This may look like a standard Ford hatchback, but its looks are deceiving. With a top speed of 144mph and 0 to 60mph in 6.4 seconds, it will not feel like a standard Ford for long.$adinfo',19000,'28,29,30',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '13, '; else print '<b>13 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (14,1,0,1995,'Mazda','RX-7','','',30000,'red','manual','You do not see many RX-7\'s on the road, so this car is one way to get noticed. At 0 to 60mph in just 5.2 seconds and a top speed of 155mph, it drives as well as it looks.$adinfo',16000,'31,32,33',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '14, '; else print '<b>14 failed</b>, ';

			$sql="INSERT INTO `example` VALUES (15,1,0,2000,'Demo','Car','','',0,'N/A','manual','This is an example car that should be deleted.',0,'',0,0,'autodirector@setup','$now');";
			if ($db->fetch($sql)) print '15</p>'; else print '<b>15 failed</b></p>';


			// SELECT test
			$sql="SELECT id FROM example;";
			print '<p>Selecting all vehicles in "example" table ... ';
			if ($db->fetch($sql)) {
				print "{$db->rowcount} vehicles returned ... ";
				if ($db->rowcount==15) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b> - 15 should have been returned?</p>';
			}
			else print '<b style="color:#f00;">FAILED</b>. Could not SELECT from table. Please check user privileges.</p>';


			// UPDATE test
			$sql="UPDATE example SET price=1000 WHERE id=15;";
			print '<p>Updating vehicle in "example" table ... ';
			if ($db->fetch($sql)) {
				print "{$db->rowcount} row updated ... ";
				if ($db->rowcount==1) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. Could not UPDATE table. Please check user privileges.</p>';
			}
			else print '<b style="color:#f00;">FAILED</b>. Could not UPDATE table. Please check user privileges.</p>';


			// DELETE test
			$sql="DELETE FROM example WHERE id=15;";
			print '<p>Deleting vehicle 15 from "example" table ... ';
			if ($db->fetch($sql)) {
				print "{$db->rowcount} row deleted ... ";
				if ($db->rowcount==1) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>.</p>';
			}
			else print '<b style="color:#f00;">FAILED</b>. Could not DELETE from table. Please check user privileges.</p>';

		}
		else print '<b style="color:#f00;">FAILED</b>. No example site will be available.</p>';


		// set permissions on DATAFOLDER
		print '<p>Setting read/write permissions on DATAFOLDER ('.DATAFOLDER.') ... ';
		if (@chmod(DATAFOLDER, 0755)) {
			print 'success.</p>';
			@chmod(DATAFOLDER . 'example', 0755);
			@chmod(DATAFOLDER . 'example/pics', 0755);
			@chmod(DATAFOLDER . 'example/thumbs', 0755);
		}
		else print '<b style="color:#f00;">FAILED</b>. It may be necessary to chmod this directory (and possibly all its sub-directories) to 755 if futher errors are encountered below.</p>';


		// generate example site files
		$thisSite=new siteObject;
		$thisSite->selectDB($db);
		$thisSite->fetchSite("example");

		print '<p>Generating data files for "example" site ... ';
		$result=generateFiles($thisSite, scriptPath(), DATAFOLDER);
		if ($result=='') print 'success.</p>'; else print "<b style=\"color:#f00;\">FAILED</b>. The following errors were reported:<br />$result</p>";

		// check file uploads
		print '<p>Checking if file uploads are permitted ... ';
		@ini_set('file_uploads', '1');
		if (ini_get('file_uploads')) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. File uploads are not permitted. AutoDirector will work, but you will not be able to upload vehicle pictures. Please check the file_uploads setting in php.ini.</p>';

		// check GD installed
		print '<p>Checking if PHP GD extension is loaded ... ';
		if (extension_loaded('gd')) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. The PHP GD extension is not available.  AutoDirector will work, but you will not be able to upload vehicle pictures. Please check your extension settings in php.ini.</p>';

		// check email sending
		$subject = 'Test message from AutoDirector setup';
		$body = "This is a test email from the AutoDirector setup. \nAutoDirector email facilities are functioning correctly. \n";
		$header = 'From: '.SUPPORTEMAIL."\n";
		print '<p>Checking email - sending message to '.SUPPORTEMAIL.' ... ';
		if (@mail(SUPPORTEMAIL, $subject, $body, $header)) print 'success.</p>'; else print '<b style="color:#f00;">FAILED</b>. AutoDirector could not send an email. AutoDirector will work, but you will not be able to add new users or receive customer enquiries by email. Please check the mail function settings in php.ini or contact your ISP.</p>';

		// disconnect from database
		$db->dbDisconnect();
	}
	else {
		print '<b style="color:#f00;">FAILED</b>. Aborting setup.</p><p>Please check that the database "'.MYSQLDBNAME.'" exists and can be accessed by "'.MYSQLDBUSER.'@'.MYSQLHOST.'" with the password "'.MYSQLDBPASS.'".</p>';
		print '<p>If they are correct, your version of PHP may be incompatible with the user security in your MySQL installation. To fix the problem, try the following MySQL command:</p><pre>SET PASSWORD FOR \''.MYSQLDBUSER.'\'@\''.MYSQLHOST.'\' = OLD_PASSWORD(\''.MYSQLDBPASS.'\');</pre>';
	}

	unset($db);

	print '<h2>Next steps</h2>';
	print '<p>Please check your settings for any test that returned <b style="color:#f00;">FAILED</b>. Once the problems have been resolved, please <a href="?start=">re-run this setup again...</a></p>';
	print '<p>If all the tests returned "success", you can now log on with the user ID "super@user.account" and password "super". This account has full supervisor privileges: please remember to change the ID and password in the <b>my account</b> section. <a href="index.php">Proceed to the login page...</a></p>';
}

// page footer
require(INCLUDEFOLDER.'adpagefoot.php');

// ________________________________________________________
// show setup information
function showInformation() {

	print '<p>The following setup parameters have been defined in autodirector.ini:</p>';

	print '<table align="center" cellpadding="2" cellspacing="2" border="0">';
	print '<tr><td><b>MYSQLHOST</b></td><td>(MySQL database server):</td><td>'.MYSQLHOST.'</td></tr>';
	print '<tr><td><b>MYSQLDBNAME</b></td><td>(MySQL database name):</td><td>'.MYSQLDBNAME.'</td></tr>';
	print '<tr><td><b>MYSQLDBUSER</b></td><td>(MySQL database user):</td><td>'.MYSQLDBUSER.'</td></tr>';
	print '<tr><td><b>MYSQLDBPASS</b></td><td>(MySQL database password):</td><td>'.MYSQLDBPASS.'</td></tr>';
	print '<tr><td><b>DATAFOLDER</b></td><td>(data storage directory):</td><td>'.DATAFOLDER.'</td></tr>';
	print '<tr><td><b>SUPPORTEMAIL</b></td><td>(support email address):</td><td>'.SUPPORTEMAIL.'</td></tr>';
	print '</table><br clear="all" />';

	print '<p>You must create a MySQL database with the name "'.MYSQLDBNAME.'" before clicking continue. This can usually be done within your website control panel, or running the following command in the MySQL command line:</p><pre>create database if not exists \''.MYSQLDBNAME.'\';</pre>';

	print '<p>A MySQL user "'.MYSQLDBUSER.'" with the password "'.MYSQLDBPASS.'" must also be defined with full privileges to the "'.MYSQLDBNAME.'" database. Again, this can be done in your control panel or by the MySQL command line:</p><pre>GRANT ALL PRIVILEGES ON '.MYSQLDBNAME.'.* TO \''.MYSQLDBUSER.'\'@\''.MYSQLHOST.'\' IDENTIFIED BY \''.MYSQLDBPASS.'\';</pre>';

	print '<p>Setup will now attempt to create the database tables and check the data storage folder.</p><p style="font-weight:bold;color:#c00;">WARNING! This process will destroy any existing AutoDirector data. Do not continue if you are upgrading from a previous installation (use <a href="upgrade.php">upgrade.php</a> instead).</p>';
	print '<p align="right"><a href="?start=go" style="font-size:1.5em;">continue setup &raquo;</a></p>';

}
?>